import { Path } from '../path';
import { ReadState } from '../state';
import { FeatureMetadata, NoFeature, PartialToken, Token, TokenExtension, _metadata } from '../token';
declare const _errorToken: unique symbol;
export interface ErrorsState {
    [path: string]: string;
}
export interface ErrorMessage {
    readonly [_errorToken]: PartialToken<ReadState<string>>;
    [_metadata]: FeatureMetadata<'error', ErrorMessage, NoFeature, {
        [P in PropertyKey]: ErrorMessage;
    }>;
}
export interface ErrorOptions {
    errorsToken: Token<ReadState<ErrorsState>>;
}
export declare function addErrorMessages(options: ErrorOptions): TokenExtension<Path, ErrorMessage>;
export declare function getTokenErrorMessage(token: PartialToken<ErrorMessage>): string | undefined;
export declare function useTokenErrorMessage(token: PartialToken<ErrorMessage> | undefined): string | undefined;
export {};
