import { SchemaOf } from 'yup';
import { Path } from '../path';
import { State } from '../state';
import { FeatureMetadata, Token, TokenExtension, _metadata } from '../token';
import { NonFunctionProperties } from '../utils/types';
import { ErrorMessage } from './error-message';
import { Schema } from './schema';
import { Validated } from './validation';
export interface FormState<TReadState, TWriteState = TReadState> extends State<TReadState, TWriteState>, Path, ErrorMessage, Validated, Schema<TReadState> {
    [_metadata]: FeatureMetadata<'formState', FormState<TReadState, TWriteState>, State<TReadState, TWriteState> & Path & ErrorMessage & Validated & Schema<TReadState>, {
        [P in keyof NonFunctionProperties<NonNullable<TReadState>> & keyof NonFunctionProperties<NonNullable<TWriteState>> & PropertyKey]-?: FormState<NonNullable<TReadState>[P] | (TReadState extends null | undefined ? undefined : never), NonNullable<TWriteState>[P]>;
    }>;
}
export interface FormOptions<TState> {
    schema: SchemaOf<TState>;
    debounceValidationMs?: number;
}
export declare function addForm<TState>(options: FormOptions<TState>): TokenExtension<State<TState>, FormState<TState>>;
export declare function useFormToken<TState>(options: FormOptions<TState>): Token<FormState<TState>>;
