import { SchemaOf } from 'yup';
import { FeatureMetadata, NoFeature, PartialToken, TokenExtension, _metadata } from '../token';
import { NonFunctionProperties } from '../utils/types';
declare const _schema: unique symbol;
export interface Schema<TState> {
    readonly [_schema]: SchemaOf<TState>;
    [_metadata]: FeatureMetadata<'schema', Schema<TState>, NoFeature, {
        [P in keyof NonFunctionProperties<NonNullable<TState>>]-?: Schema<NonNullable<TState>[P]>;
    }>;
}
export declare function addSchema<TState>(schema: SchemaOf<TState>): TokenExtension<NoFeature, Schema<TState>>;
export declare function getTokenSchema<T>(token: PartialToken<Schema<T>>): SchemaOf<T>;
export interface SchemaInfo {
    label?: string;
    required?: boolean;
}
export declare function useTokenSchemaInfo(token: PartialToken<Schema<any>> | undefined): SchemaInfo;
export {};
